/**
 * Esta classe modela a informao de um CD .
 *  subclasse da classe ItemMultimedia da qual herda todo o estado e comportamento 
 * a definido.
 * 
 * 
 * @author Michael Kolling and David J. Barnes (alterado por anr)
 * @version Maio 2006
 */
public class CD extends ItemMultimedia
{
    private String artist;
    private int numberOfTracks;

    /**
     * Construtor vazio - no foi feito. No respeita o invariante de estado de um CD.
     * E no seria possvel utilizar o ttulo como chave para pesquisa
     */
   
    
    
    /**
     * Construtor parametrizado
     */
    public CD(String title, String artist, int tracks, int time, boolean gotIt, String comment)
    {
        //invocaoo do construtor da superclasse
        super(title,time,gotIt,comment);     
        this.artist = artist;
        this.numberOfTracks = tracks;
     }

     
      /**
     * Construtor de cpia
     */
    public CD(CD aCD)
    {
        //invocao do construtor de cpia da superclasse
        super(aCD);   //ateno: existe compatibilidade de tipos entre um CD e um ItemMultimedia    
        this.artist = aCD.getArtist();
        this.numberOfTracks = aCD.getNumberOfTracks();
     }

     
     

    /**
     * Mtodo que devolve o nome do artista do CD
     * 
     * @return String com o nome
     */
    
    public String getArtist() {
      return this.artist;
    }


   /**
    * 
    * Mtodo que devolve o nmero de faixas que o CD tem.
    * 
    * @return inteiro com o nmero de pistas
    */
   
   public int getNumberOfTracks() {
     return this.numberOfTracks;
   }


    /**
     * Devolve uma String com a representaao do objecto CD
     *  a implementao do mtodo toString() que foi herdado 
     * da superclasse ItemMultimedia
     * 
     * @return String com a informao 
     */
    public String toString() {
      StringBuffer sres = new StringBuffer();
      
      sres.append(" CD [");
      sres.append("Artist: "); sres.append(this.artist);
      sres.append(" Number of Tracks: "); sres.append(this.numberOfTracks);
      sres.append(super.toString()); //invocao do toString() de ItemMultimedia
      sres.append(" ]");
      
      return sres.toString();
    }
    
    
    /**
     * Mtodo equals - devolve o resultado da comparao semntica entre dois objectos
     * que sejam instncias de CD.
     * 
     * @return boolean indicando se a comparao  true ou false
     */
    
    public boolean equals(Object o) {
       if (this == o)
         return true;
         
       if ((o!= null) && this.getClass()==o.getClass()) {
           CD aCD = (CD)o;
           return(super.equals(aCD) && this.artist.equals(aCD.getArtist()) &&
                  this.numberOfTracks == aCD.getNumberOfTracks());
       }
       else
         return false;
        
    }    
    
    
    /*
     *Mtodo que providencia uma cpia do objecto a quem  enviado.
     *
     *@return Object com a cpia campo por campo
     */
    
    public Object clone() {
      return new CD(this);   
    }    
    
}
