/**
 * Classe que modela a informao que queremos guardar acerca de um
 * DVD. Esta classe  subclasse de ItemMultimedia.
 * 
 * @author Michael Kolling and David J. Barnes (revisto por anr)
 * @version Maio 2003
 */
public class DVD extends ItemMultimedia
{
    private String director;

    /**
     * Construtor vazio - no foi feito. No respeita o invariante de estado de um DVD.
     * E no seria possvel utilizar o ttulo como chave para pesquisa
     */
   
    
    
    /**
     * Construtor parametrizado para um DVD
     */
    public DVD(String theTitle, String theDirector, int time, boolean gotIt, String comment)
    {
        
        //invocao do construtor parametrizado de ItemMultimedia
        super(theTitle,time,gotIt,comment);
        this.director = theDirector;
    }


    /**
     * Construtor de cpia
     */

    public DVD(DVD aDVD) {
      super(aDVD);
      this.director = aDVD.getDirector();
    }
    
    
    
    public void setDirector(String director) {
        this.director = director;
    }
    
    public String getDirector() {
      return this.director;   
    }
    

    /**
     * Devolve uma String com a representao do objecto DVD a que
     *  enviado.
     * 
     * @return String com a informao
     */
    public String toString() {
      StringBuffer sres = new StringBuffer();
      
      sres.append(" DVD [");
      sres.append("Director: "); sres.append(this.director);
      sres.append(super.toString()); //invocao do toString() de ItemMultimedia
      sres.append(" ]");
      
      return sres.toString();
    }
    
     /**
     * Mtodo equals - devolve o resultado da comparao semntica entre dois objectos
     * que sejam instncias de DVD.
     * 
     * @return boolean indicando se a comparao  true ou false
     */
    
    public boolean equals(Object o) {
       if (this == o)
         return true;
         
       if ((o!= null) && this.getClass()==o.getClass()) {
           DVD aDVD = (DVD)o;
           return(super.equals(aDVD) && this.director.equals(aDVD.getDirector()));
       }
       else
         return false;
        
    }    
    
    
    /*
     *Mtodo que providencia uma cpia do objecto a quem  enviado.
     *
     *@return Object com a cpia campo por campo
     */
    
    public Object clone() {
      return new DVD(this);   
    }    
    
    

}
